-- | Encodes the security lattice used in the library (trusted).
module Lattice where

-- Security types

-- | Data type representing the security level associated to public information.
data L = L -- ^ Key to access public information. 

-- | Data type representing the security level associated to secret information.
data H = H -- ^ Key to access secret information.


-- Less
class Less s s' where
  -- | This method determines that information at security level s can be pushed up to security level s\' (not exported to untrusted code).
  less :: s -> s' -> () 


-- -- Top
-- class Top s where
--    -- | 'top' returns the highest security level in the lattice.
--    top :: s


-- -- Bottom 
-- class Bottom s where
--   -- | 'bottom' returns the lowest security level in the lattice.
--   bottom :: s


-- Security lattice for confidentiality 
instance Less L L where
  less _ _ = ()


instance Less H H where
  less _ _ = ()

instance Less L H where 
  less _ _ = () 
