-- | The security library.  This is the * only * module of the library to be imported by untrusted code.
module SecLib
  ( 
  -- Sec
    Sec   
  , up
  -- SecIO
  , SecIO 
  , value
  , plug
  -- Files
  , File 
  , SecIO.readFileSecIO
  , SecIO.writeFileSecIO
  , SecIO.newFileSecIO
  -- References
  , Ref 
  , SecIO.readRefSecIO
  , SecIO.writeRefSecIO 
  , SecIO.newIORefSecIO
  -- Network 
  , SecSocket   
  , SecSockAddr  
  , inet_addrSecIO   
  , bindSocketSecIO
  , sIsBoundSecIO
  , acceptSecIO
  , socketSecIO
  , recvSecIO
  , sendSecIO
  -- Screen/Keyword
  , Screen 
  , getLineSecIO
  , putStrSecIO
  , makeScreen
  -- Legacy code
  , s_read
  , s_write
  -- Declassification
  , Hatch
  , Open
  , Close
  , Authority   
  , certify
  -- Lattice 
  , L (..) 
  , H (..)
  , Less ()     -- Method less must not be exported!
  )
where

import Lattice
import Sec
import SecIO 
import Declassification
